 DEFINE rel ;comment for sna,un for code

	device zxspectrum128

;        ORG #BD00
; incbin "firesin.bin"
;        ORG #BE00
;fp_b:
; dup 8
; db 0
;edup
;
; dup 8
; db 0
;edup
;
;
; dup 15
; db 0
;edup
;
; db 1
;
; dup 4
; db 2
;edup
;
; dup 4
; db 2*9
;edup
;
; dup 4
; db 2*8+6
;edup
;
; dup 8
; db 6*8+7
;edup
;
; dup 12
; db $47
;edup
;
; dup 64
; db 7*9
;edup
;
; dup 128
; db 7;3*9
;edup
;fp_e:
;edup

        ORG #6000
begin

; fill greed
	ld hl,$4000
gl1:
	ld a,h
	rra
	sbc a,a
	xor $55
gl2:
	ld (hl),a
	inc l
	jr nz,gl2
	inc h
	ld a,h
	cp $58
	jr nz,gl1

;	ld hl,$BE00,de,$5800,bc,256:ldir
;	jr $
;ff: ld (hl),l:inc l:jr nz,ff

;zero memory
	ld hl,$8000
zm:
	ld (hl),0:inc l:jr nz,zm
	inc h
	ld a,h:cp $C0:jr nz,zm
;copy data
	ld hl,st,de,$BD00,bc,512:ldir
;prepare routine
	ld hl,atr_b,de,atr_e,bc,767*(atr_e-atr_b):ldir
	ld a,$C9,(de),a
flp:
	ld ix,$8020
	ld bc,$8400
	ld d,0
;	ld hl,0
fl1:
	ld hl,0
	
	ld e,(ix-1)
	add hl,de

	ld e,(ix+1)
	add hl,de

	ld e,(ix-33)
	add hl,de
;
	ld e,(ix-32)
	add hl,de
;
	ld e,(ix-31)
	add hl,de

	ld e,(ix+31)
	add hl,de

	ld e,(ix+32)
	add hl,de

	ld e,(ix+33)
	add hl,de

	dup 3
	srl h:rr l
edup
	ld a,l
;	or a:jr z,nod
;	dec a
	ld (bc),a
nod:
	inc ix
	inc bc
	ld a,b
	cp $87
	jp nz,fl1

;draw balls
bp0:  ld a,0
	add a,5
	ld (bp0+1),a
	ld h,$BD
	ld l,a
	ld a,(hl)
	ld h,0,l,a
	ld de,$8640
	add hl,de
	call addball

bp1:  ld a,64*2
	add a,6
	ld (bp1+1),a
	ld h,$BD
	ld l,a
	ld a,(hl)
	ld h,0,l,a
	ld de,$85C0
	add hl,de
	call addball

	ld hl,$8400,de,$8000,bc,768+32:ldir
	ei:halt
	ld a,(notecnt)
	;and 7:out ($FE),a
	cp $1C:jp z,blackscr
	ld hl,$8400
	ld bc,$5800
	ld d,$BE
	call atr_b
; dup 768
; ld e,(hl),a,(de),(bc),a
; inc hl,bc
;edup
	jp flp
addball:
	ld de,ball

	ld c,6
ylp:
	ld b,6
	push hl
xlp:
	ld a,(de)
	;or (hl)
	add a,(hl)
	ld (hl),a
	inc de
	inc hl
	djnz xlp
	pop hl
	push bc
	ld bc,32
	add hl,bc
	pop bc
	dec c
	jr nz,ylp
	ret
ball:
bv	equ 15
	db 00,bv,bv,bv,bv,00
	db bv,bv,bv,bv,bv,bv
	db bv,bv,bv,bv,bv,bv
	db bv,bv,bv,bv,bv,bv
	db bv,bv,bv,bv,bv,bv
	db 00,bv,bv,bv,bv,00

 IFNDEF rel
 include "../utils.inc"
 ELSE
 include "../demovars.inc"
 ENDIF
 
atr_b:
 ld e,(hl),a,(de),(bc),a
 inc hl,bc
atr_e:

st: incbin "firesin.bin"
pal:
 dup 8
 db 0
edup

 dup 8
 db 0
edup


 dup 15
 db 0
edup

 db 1

 dup 4
 db 2
edup

 dup 4
 db 2*9
edup

 dup 4
 db 2*8+6
edup

 dup 8
 db 6*8+7
edup

 dup 12
 db $47
edup

 dup 64
 db 7*9
edup

 dup 128
 db 7;3*9
edup

end
;	display /d,end-begin
;	savesna "!void.sna",begin
;	savebin "firepal.bin",fp_b,fp_e-fp_b

	display /d,end-begin
 IFNDEF rel
	savesna "fire.sna",begin
 ELSE
	savebin "08fire.code",begin,end-begin
 ENDIF
