 DEFINE rel ;comment for sna,un for code

	device zxspectrum128
        ORG #6000
begin

bw	equ $B800
;generate data for output
	ld hl,bw
genlp:
	ld a,l
	ld b,8
	push hl
ge2:
	add a,a
	push af
	sbc a,a
	and 7-1
	ld (hl),a
	inc h
	pop af
	djnz ge2
	pop hl
	inc l
	jr nz,genlp

;	jr $
	ei
	ld a,$10:call bank01
	ld hl,fntp,de,$A800:call dzx7_standard
	ld hl,sprp,de,$C000:call dzx7_standard
	
;	jr $
;	ld b,bw/256 6
;	ld c,(hl) 4E
;	inc hl 23
;	ld a,(bc) 0A
;	ld (de),a 12
;	inc b 4
;	inc de 13

;draw grid
	ld hl,#4040
grlp:
	push hl
	ld (hl),$00:inc h
	ld (hl),$7F:inc h
	ld (hl),$7F:inc h
	ld (hl),$7F:inc h
	ld (hl),$7F:inc h
	ld (hl),$7F:inc h
	ld (hl),$7F:inc h
	ld (hl),$7F:inc h
	pop hl
	inc l
	jr nz,grlp
	ld a,h
	add a,8
	ld h,a
	cp $58
	jr nz,grlp
;prepare routine
	ld hl,sout
	ld a,22
fo1:
	exa
	ld c,3
fo2:
	ld (hl),6:inc hl
	ld (hl),bw/256:inc hl
	ld (hl),$4E:inc hl
	ld (hl),$23:inc hl
	ld b,8
fo3:
	ld (hl),$0A:inc hl
	ld (hl),$12:inc hl
	ld (hl),$4:inc hl
	ld (hl),$13:inc hl
	djnz fo3
	dec c:jr nz,fo2
	ld b,8
fo4:
	ld (hl),$13:inc hl
	djnz fo4
	exa
	dec a
	jp nz,fo1
	ld (hl),$c9:inc hl

	xor a:call fila
	ld hl,$5800
whi:
	ld (hl),$47
	inc l
	bit 6,l
	jr z,whi
	ld ix,t1:call prtext
;	jr $
zul:
	ei:halt;:halt:halt:halt
;	ld a,(notecnt)
;	and 7:out ($FE),a
dl: ld a,0
	inc a
	ld (dl+1),a
	and 3
	jp nz,endanim
dc:ld a,0
	push af
;*72=3*3*8
	ld l,a,h,0
	add hl,hl
	add hl,hl
	add hl,hl ;*8
	ld de,hl
	add hl,hl
	add hl,de;*3
	ld de,hl
	add hl,hl
	add hl,de
	ld de,$C000
	add hl,de
	ld de, #5844
	call sout
	pop af
	inc a
	cp 68-1
	jr nz,noloopf
	xor a
noloopf:
	ld (dc+1),a
endanim: call sync1
	jp zul
sync1:
	ld a,(notecnt)
	cp $20:ret nz
	ld ix,t2:call prtext
	ld hl,sync2,(endanim+1),hl
	ret
sync2:
	ld a,(notecnt)
	cp $21:ret nz
	ld ix,t3:call prtext
	ld hl,sync3,(endanim+1),hl
	ret
sync3:
	ld a,(notecnt)
	cp $22:ret nz
	pop af
	jp blackscr
;	ret

t1: db "       Greetz to visitors      ",0
t2: db "And to all who keep scene alive",0
t3: db "   And...no greets to diver!   ",0
prtext:;IX=pointer
	ld de,$4000
pr1:
	ld a,(ix+0):inc ix
	or a:ret z
	ld h,0,l,a
	ld bc,$A800
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld b,16
	push de
pr2:
	ld a,(hl),(de),a
	inc hl
	call nbde
	djnz pr2
	pop de
	inc e
	jp pr1

 IFNDEF rel
 include "../utils.inc"
 ELSE
 include "../demovars.inc"
 ENDIF

sout:
sprp:incbin "dancer.bin.zx7"
fntp:incbin "THIN.FNT.zx7"
end
	display /d,end-begin
 IFNDEF rel
	savesna "dancer.sna",begin
 ELSE
	savebin "10dancer.code",begin,end-begin
 ENDIF
