;   utils.inc
; uservar1 - 4
	device zxspectrum128
        ORG #5C00

begin
 di
 jp start_demo
 include "utils.inc"
callbyHL: jp (hl)
;--------------int--------
INTVEC  PUSH AF,BC,DE,HL,IX
        EXX:PUSH AF,BC,DE,HL
        EXA:PUSH AF

        ld hl,(callb4)
        ld a,h:or l:call nz,callbyHL

        ld a,(curpage):and #18:or 1
        ld bc,#7FFD:out (c),a
        call PLAY
 ld a,(CurPos)
 ld (notecnt),a
        ld a,(curpage)
        ld bc,#7FFD:out (c),a
v1:ld hl,0:inc hl:ld (v1+1),hl,(intcnt),hl
        POP AF:EXA
        POP HL,DE,BC,AF:EXX
        POP IX,HL,DE,BC,AF
        EI:RETI

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start_demo:


 ld sp,#5ff0

 xor a:out (#FE),a
 ld a,#10,(curpage),a
 ld hl,#5AFF,de,#5AFE,(hl),0,bc,6144:lddr; 
 ld a,#11,bc,#7FFD:out (c),a
 ld hl,song:call INIT
; call initprint
;------setup interrupt-----------------
 LD A,#5B,I,A:IM 2
 LD HL,INTVEC,(#5BFF),HL

;--------------------------title
 ;jr $

;title
 ld a,#10
 call bank02
 ld de,#6000
 ld hl,part1b
 ld bc,part1e-part1b
 call runpart1; just copy, no halt

;77-color squares
 ld a,#10
 call bank02
 ld de,#6000
 ld hl,part2b
 ld bc,part2e-part2b
 call runpart1

;00-blobby
 ld a,#10
 call bank02
 ld de,#6000
 ld hl,part3b
 ld bc,part3e-part3b
 call runpart1

;56-killed
 ld a,#10
 call bank02
 ld de,#6000
 ld hl,part4b
 ld bc,part4e-part4b
 call runpart1

;1111-tv
 ld a,#10
 call bank02
 ld de,#6000
 ld hl,part5b
 ld bc,part5e-part5b
 call runpart1

;9,10-freak
 ld a,#10
 call bank02
 ld de,#6000
 ld hl,part6b
 ld bc,part6e-part6b
 call runpart1

;888,13 cool
 ld a,#10
 call bank02
 ld de,#6000
 ld hl,part7b
 ld bc,part7e-part7b
 call runpart1

;11,11,14,14 sindots
 ld a,#10
 call bank02
 ld de,#6000
 ld hl,part8b
 ld bc,part8e-part8b
 call runpart1

;15,15,15,15 fire blob
 ld a,#10
 call bank02
 ld de,#6000
 ld hl,part9b
 ld bc,part9e-part9b
 call runpart1

;16,17 -bars
 ld a,#10
 call bank02
 ld de,#6000
 ld hl,part10b
 ld bc,part10e-part10b
 call runpart1

;18,18,18,18 -greets(dancer)

 ld a,#13
 call bank02
 ld de,#6000
 ld hl,part11b
 ld bc,part11e-part11b
 call runpart1

; 8 8 8 8 smile

 ld a,#13
 call bank02
 ld de,#6000
 ld hl,part12b
 ld bc,part12e-part12b
 call runpart1

;finale
 ld a,#13
 call bank02
 ld de,#6000
 ld hl,part14b
 ld bc,part14e-part14b
 call runpart1

stp:
	ld a,(notecnt)
	and 7
	out ($FE),a
	jr stp

end


 PAGE 0
 ORG $C000
page0b:

part1b:
 incbin "00title.code"
part1e:

part2b:
 incbin "01colsq.code"
part2e:

part3b:
 incbin "02blobby.code"
part3e:

part4b:
 incbin "03killed.code"
part4e:

part5b:
 incbin "04tv.code"
part5e:

part6b:
 incbin "05freak.code"
part6e:

part7b:
 incbin "06cool.code"
part7e:

part8b:
 incbin "07sinedots.code"
part8e:

part9b:
 incbin "08fire.code"
part9e:

part10b:
 incbin "09bars.code"
part10e:


page0e:

;---------------------------------------------------
		PAGE 1
        ORG #C000
page1b:
plyer:include "PTxPlay.a80"
song:incbin "caprize.PT3"

page1e:

 PAGE 3
 ORG $C000
page3b:
part11b:
 incbin "10dancer.code"
part11e:

part12b:
 incbin "11smile.code"
part12e:

part14b:
 incbin "12finale.code"
part14e:

page3e:



	LUA

	local fp = assert(io.open("demovars.inc", "wb"))


   local ss=tostring( sj.get_label("uservar1") )
   ss=string.gsub(ss , "%s", "")
   fp:write("uservar1=")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("curpage") )
   ss=string.gsub(ss , "%s", "")
   fp:write("curpage =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("notecnt") )
   ss=string.gsub(ss , "%s", "")
   fp:write("notecnt =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("intcnt") )
   ss=string.gsub(ss , "%s", "")
   fp:write("intcnt =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("callb4") )
   ss=string.gsub(ss , "%s", "")
   fp:write("callb4 =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("dzx7_standard") )
   ss=string.gsub(ss , "%s", "")
   fp:write("dzx7_standard =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("nbde") )
   ss=string.gsub(ss , "%s", "")
   fp:write("nbde =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("nbhl") )
   ss=string.gsub(ss , "%s", "")
   fp:write("nbhl =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("fila") )
   ss=string.gsub(ss , "%s", "")
   fp:write("fila =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

--   local ss=tostring( sj.get_label("texto") )
--   ss=string.gsub(ss , "%s", "")
--   fp:write("texto =")
--   fp:write(string.format("#%x",ss) )
--   fp:write("\r\n")
   
   local ss=tostring( sj.get_label("bank01") )
   ss=string.gsub(ss , "%s", "")
   fp:write("bank01 =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")
   
   local ss=tostring( sj.get_label("bank02") )
   ss=string.gsub(ss , "%s", "")
   fp:write("bank02 =")
   fp:write(string.format("#%x",ss) )
   fp:write(";no halt to switch\r\n")

   local ss=tostring( sj.get_label("blackscr") )
   ss=string.gsub(ss , "%s", "")
   fp:write("blackscr =")
   fp:write(string.format("#%x",ss) )
   fp:write(";black screen\r\n")
	assert(fp:close())
	ENDLUA

;-----------------------------------------------------------
 macro	sectors datab,datae

 IF low (datae-datab)=0
   db 1,5,high (datae-datab)
 ELSE
   db 1,5,(1+high (datae-datab))
 ENDIF

	endm

 MODULE boot
Basic:
 db #00,#01; 
 DW EndLine1 - Line1
Line1:
 db #EA;REM
 ld sp,#5FFE

    res 4,(iy+1)
    xor a:out ($FE),a
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr

;demo
 di
 ld de,(#5CF4)
 ld hl, #6000
 ld a,#10,bc,#7FFD:out (c),a
 sectors begin,end
 call #3d13

 di
 ld de,(#5CF4)
 ld hl, #C000
 sectors page0b,page0e
 call #3d13

 di
 ld de,(#5CF4)
 ld hl, #C000
 ld a,#11,bc,#7FFD:out (c),a
 sectors page1b,page1e
 call #3d13

 di
 ld de,(#5CF4)
 ld hl, #C000
 ld a,#13,bc,#7FFD:out (c),a
 sectors page3b,page3e
 call #3d13

; di
; ld de,(#5CF4)
; ld hl, #C000
; ld a,#14,bc,#7FFD:out (c),a
; sectors page4b,page4e
; call #3d13
;
; di
; ld de,(#5CF4)
; ld hl, #C000
; ld a,#16,bc,#7FFD:out (c),a
; sectors page6b,page6e
; call #3d13
 
  di
 ld a,#d5,(#5b00),a
 ld a,#ed,(#5b01),a
 ld a,#b0,(#5b02),a
 ld a,#c9,(#5b03),a
 ld a,#10,bc,#7ffd:out (c),a
 ld hl,#6000
 ld de,#5C00
 ld bc,end-begin
 jp #5b00


 db "whut?7"
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 db #20,#FD,#B0
 db #22,#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29,#0D;)
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
EndBasic:
 ENDMODULE

    EMPTYTRD "makes.trd" ;create empty TRD image
	SAVETRD "makes.trd", "boot.B", boot.Basic, boot.EndBasic - boot.Basic
    SAVETRD "makes.trd","demo.C",begin,end-begin

    PAGE 0
    SAVETRD "makes.trd","pg0.C",page0b,page0e-page0b
    PAGE 1
    SAVETRD "makes.trd","pg1.C",page1b,page1e-page1b
    PAGE 3
    SAVETRD "makes.trd","pg3.C",page3b,page3e-page3b
;    PAGE 4
;    SAVETRD "makes.trd","pg4.C",page4b,page4e-page4b
;    PAGE 6
;    SAVETRD "makes.trd","pg6.C",page6b,page6e-page6b

	display /d,end-begin
	savesna "makes.sna",begin

;-----------------------------------------------------------
