 DEFINE rel ;comment for sna,un for code

	device zxspectrum128
        ORG #6000
begin
; prepare data
stp equ $b000

;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir
	ei
	call blackscr
	ld a,$47:call fila
	ld a,$17:call bank01;,bc,$7ffd:out (c),a
	ld hl,$4000,de,$C000,bc,6912:ldir

;buffer
	ld hl,$4000,($A000),hl
	ld hl,$A000,de,$A002,bc,4096-4:ldir

	ld hl,st,de,stp,bc,512:ldir
	
	ld hl,stp;+256
addl:
	ld a,(hl)
	add a,16
	ld (hl),a
	inc l
	jr nz,addl

ppl	equ stp+512
;generate data for plot
	LD DE,#C000,BC,#8000,L,E
FLP1    LD H,high ppl
        LD (HL),D
        INC H
        LD (HL),E
        INC H
        LD (HL),C
        INC H
        LD (HL),B
        RRC B
        LD A,C:ADC A,0:LD C,A
FBR1    INC D:LD A,D:AND 7
        JR NZ,FNXT:LD A,E:ADD A,32
        LD E,A:JR C,FNXT
        LD A,D:SUB 8:LD D,A
FNXT    INC L:JR NZ,FLP1

;	jr $
	ld a,0:call tunepar
sdbeg:
	ld ixh,128
sinedots:; ei:halt
	push ix
pg: ld a,$17
	call bank01
;	ld bc,$7FFD
;	out (c),a
	xor $0A
	ld (pg+1),a

;	ld a,0:out ($FE),a
	ld a,(notecnt)
;	and 7:out ($FE),a
	cp $18
	jr nz,noexit;ret z
	pop ix
	jp blackscr;ret
noexit:
	ld (back_sp+1),sp
;	jr $
spv1: ld sp,$A000
	xor a
 dup 256
 pop hl
 ld (hl),a
edup

;	jr $
;spv2: ld sp,$a200
	ld ixl,0
sdv2:	ld de,0
	ld a,e
sdp3:	add a,7-6
	ld e,a
	ld a,d
sdp4:	add a,8-6
	ld d,a
	ld (sdv2+1),de

	exx
	ld h,stp/256
sdv1:	ld de,0
	ld a,e
sdp5:	add a,9-6
	ld e,a
	ld a,d
sdp6:	add a,10-6
	ld d,a
	ld (sdv1+1),de
sdp0:	ld bc,$0304;$0F0E;$FE01
	exx

sdlp:
	ld h,1+stp/256
	exx
	ld a,e
	add a,B;$FE
	ld e,a

	ld a,d
	add a,c;1
	ld d,a

	ld l,e
	ld a,(hl)
	ld l,d
	add a,(hl)
;	add a,16*2
	exx
	ld b,a

	ld l,e
	ld a,(hl)
	ld l,d
	add a,(hl)
	ld c,a
	inc h

	ld l,b
	ld b,(hl)
	inc h

	ld a,(hl)
	ld l,c
	inc h
	add a,(hl)
	inc h
	ld c,a
	ld a,(bc)
	or (hl)
	ld (bc),a
	push bc
	ld a,e
sdp1:	add a,$02;$10;$82
	ld e,a
	ld a,d
sdp2:	add a,$FF;$0F;$83
	ld d,a
	dec ixl
	jp nz,sdlp
back_sp:ld sp,0
;	ld a,7:out ($FE),a
	ld a,(spv1+2):xor 4:ld (spv1+2),a
;	ld a,(spv2+2):xor 4:ld (spv2+2),a
	pop ix
	dec ixh
	jp nz,sinedots
parc: ld a,0
	inc a
	cp 7
	jr nz,noparlp
	xor a
noparlp:
	ld (parc+1),a
	call tunepar
	jp sdbeg
tunepar: ;A=#
	push af
	ld l,a,h,0
	ld de,partab
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	ld a,(hl):inc hl:ld (sdp0+2),a
	ld a,(hl):inc hl:ld (sdp0+1),a
	ld a,(hl):inc hl:ld (sdp1+1),a
	ld a,(hl):inc hl:ld (sdp2+1),a

	ld a,(hl):inc hl:ld (sdp3+1),a
	ld a,(hl):inc hl:ld (sdp4+1),a
	ld a,(hl):inc hl:ld (sdp5+1),a
	ld a,(hl):inc hl:ld (sdp6+1),a

	ld hl,0,(sdv1+1),hl,(sdv2+1),hl
	pop af
	ret
partab:
 db $FE,1,$82,$83,7-4,8-4,9-4,10-4;!cool
 db $0F,$0E,$10,$0F,7,8,9,10
 db 3,4,2,$FF,7,8,9,10
 db $10,$0F,$10,$0f,7,8,9,10
 db $02,$03,$FF,$7C,7-5,8-5,9-5,10-5
 db $04,$45,$06,$47,7-6,8-6,9-6,10-6
 db $01,$04,$01,$02,1+3,2+3,3+3,4+3

 IFNDEF rel
 include "../utils.inc"
 ELSE
 include "../demovars.inc"
 ENDIF
st:incbin "6900.bin"
 incbin "6800.bin"
end
	display /d,end-begin
 IFNDEF rel
	savesna "sinedots.sna",begin
 ELSE
	savebin "07sinedots.code",begin,end-begin
 ENDIF
