 DEFINE rel ;comment for sna,un for code

	device zxspectrum128
        ORG #6000
begin
sinp equ $B000

;stack routine
	ld hl,ou
	ld de,$401F
	ld a,192
fo1:
	exa
	push de
	ld de,r_b
	ex de,hl
	ld bc,r_e-r_b
	ldir
	ex de,hl
	pop de
	inc de
	ld (hl),e:inc hl
	ld (hl),d:inc hl
	dec de
	call nbde
	ld b,16
fo2:
	ld (hl),$D5
	inc hl
	djnz fo2
	
	exa
	dec a
	jp nz,fo1
	ld (hl),$31:inc hl
	ld (ous+2),hl
	inc hl,hl
	ld (hl),$C9

;generate sinus table
	exx
	ld bc,sinp
	exx
	ld	hl, 0
	ld de,hl

; cp $10,bc,$10=32
gens:
	ld	a, h
	cp	40
	ex	de, hl
	ld	bc,5
	jr	c, bra1
	and	a
	sbc	hl, bc
	jr	bra2
bra1:
	add	hl, bc
bra2:
	ex	de, hl
	add	hl, de
	
	ld a,h
	exx
	ld (bc),a
	inc c
	exx
	jr nz,gens

;zero
	ld hl,barp
zm: ld (hl),0:inc l:jr nz,zm

;!go
	ld a,$47
	call atra
	ld ixh,c
;
barp equ sinp+256
zu:
	ei:halt
	ld a,(notecnt)
;	and 7:out ($FE),a
	cp $1E+1
	jp z,blackscr

	ld hl,barp
	call ous
	exx
v1: ld a,0
av3:	add a,3
	ld (v1+1),a
	ld c,a
v2: ld a,0
	add a,2
	ld (v2+1),a
	ld b,a
	exx
	ld a,12
ca1:
	exa
	exx
	ld h,sinp/256
	ld l,c
	ld e,(hl)

	ld a,c
av1: add a,8
	ld c,a

	ld l,b
	ld a,e
	add a,(hl)
	ld e,a
	ld a,b
av2: add a,$F4
	ld b,a
	ld a,e
	exx
	ld h,barp/256
	ld l,a
	ld de,rs_b
	ld b,rs_e-rs_b
ca2:
	ld a,(de),(hl),a
	inc de,l
	djnz ca2
	exa
	dec a
	jr nz,ca1

	dec ixh
	jr nz,zu
	
cv1: ld a,-1
	inc a
	ld (cv1+1),a
	and 3
	ld l,a,h,0,de,cta
	add hl,de
	ld a,(hl)
	call atra

	ld a,r
	and 7
	inc a
	ld (av1+1),a
	and 3
	ld (av3+1),a
	
;	neg
;	ld (av2+1),a
	jr zu
cta: db $46,$45,$47,$44
atra:
	ld hl,$5800,de,$5801,bc,767,(hl),a:ldir
	ret
rs_b:
	db 0
	db $55,$AA
	db $FF
	db $FF
	db $FF
	db $FF
	db $AA,$55
	db 0
rs_e:

 IFNDEF rel
 include "../utils.inc"
 ELSE
 include "../demovars.inc"
 ENDIF

;nbde    INC D:LD A,D:AND 7:RET NZ
;        LD A,E:ADD A,#20:LD E,A:RET C
;        LD A,D:SUB 8:LD D,A:RET
r_b:
	ld e,(hl)
	ld d,e
	ld (hl),0
	inc hl
	db $31 ; ld SP,
r_e:
ous: ld (0),sp
ou:

end
;	display /d,end-begin
;	savesna "!void.sna",begin
;	savebin "bars.code",begin,end-begin
	display /d,end-begin
 IFNDEF rel
	savesna "bars.sna",begin
 ELSE
	savebin "09bars.code",begin,end-begin
 ENDIF
